package com.liang.dao;

import com.liang.entity.StaProjectExpenses;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 项目费用支出（StaProjectExpensesDao）表数据库访问层
 */
public interface StaProjectExpensesDao {
    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaProjectExpenses queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staProjectExpenses 查询条件
     * @param pageable           分页对象
     * @return 对象列表
     */
    List<StaProjectExpenses> queryAllByLimit(StaProjectExpenses staProjectExpenses, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staProjectExpenses 查询条件
     * @return 总行数
     */
    long count(StaProjectExpenses staProjectExpenses);

    /**
     * 新增数据
     *
     * @param staProjectExpenses 实例对象
     * @return 影响行数
     */
    int insert(StaProjectExpenses staProjectExpenses);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<staProjectExpenses> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaProjectExpenses> entities);

    /**
     * 修改数据
     *
     * @param staProjectExpenses 实例对象
     * @return 影响行数
     */
    int update(StaProjectExpenses staProjectExpenses);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除项目费用支出
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入项目费用支出
     *
     * @param entities
     * @return
     */
    int insertBatch(@Param("entities") List<StaProjectExpenses> entities);

    /**
     * 获取项目费用支出列表
     *
     * @return
     */
    List<StaProjectExpenses> getXmfyList(Integer zb);
}
